;;;; -*- Mode: Lisp -*-
;;;; $Id: package.lisp 612 2008-11-14 07:06:04Z binghe $

(in-package :cl-user)

(defpackage asn.1
  (:use #+genera :future-common-lisp
        #-genera :common-lisp
        #+lispworks :parsergen
        :trivial-gray-streams)
  (:export #:asn.1-type
           #:ber-decode
	   #:ber-decode<-string
           #:ber-decode-value
           #:ber-encode
	   #:ber-encode->string
           #:ber-encode-length
	   #:ber-encode-list
           #:ber-encode-type
           #:ber-equal
           #:ber-stream
           #:compile-asn.1
           #:counter
           #:counter32
           #:counter64
           #:defunknown
           #:defoid
           #:delete-object
           #:gauge
           #:general-type
           #:get-asn.1-type
           #:install-asn.1-type
           #:integer
           #:ipaddress
           #:load-asn.1
           #:mibrowser
           #:object-id
           #:oid
           #:oid-find-leaf
           #:oid-leaf-p
           #:oid-length
           #:oid-name
           #:oid-name-list
           #:oid-next
           #:oid-walk
           #:oid-number-list
           #:oid-parent
           #:oid-parent-p
           #:oid-scalar-variable-p
           #:oid-trunk-p
           #:oid-value
	   #:oid-<
	   #:oid->=
           #:opaque
           #:plain-value
           #:raw
           #:string
           #:timeticks
           #:uninstall-asn.1-type
	   #:value-of))

(in-package :asn.1)

;;; Logical Pathname Translations, learn from CL-HTTP source code
(eval-when (:load-toplevel :execute)
  (let* ((defaults #+asdf (asdf:component-pathname (asdf:find-system :asn.1))
                   #-asdf *load-pathname*)
         (home (make-pathname :name :wild :type :wild
                              :directory (append (pathname-directory defaults)
                                                 '(:wild-inferiors))
                              :host (pathname-host defaults)
                              :defaults defaults
			      :version :newest)))
    (setf (logical-pathname-translations "ASN")
          `(("**;*.*.NEWEST" ,home)
	    ("**;*.*" ,home)))))

(defparameter *major-version* 4)
(defparameter *minor-version* 14)
