;;;; Patch 4.13: fix SEQUENCE decode bug on unknown ASN.1 data (RAW)

(in-package :asn.1)

(setf *minor-version* 13)

(defmethod ber-decode-value ((stream stream) (type (eql :sequence)) length)
  (declare (type fixnum length) (ignore type))
  "Decode ASN.1 sequence data and return a VECTOR"
  (if (zerop length) #()
    ;; for non-null sequence
    (labels ((iter (length-left acc)
               (if (zerop length-left)
                 (nreverse acc)
                 (multiple-value-bind (sub-type sub-type-length sub-type-bytes)
                     (ber-decode-type stream)
                   (multiple-value-bind (sub-length sub-length-length sub-length-bytes)
                       (ber-decode-length stream)
                     (iter (- length-left
                              sub-type-length
                              sub-length-length
                              sub-length)
                           (cons (if sub-type (ber-decode-value stream sub-type sub-length)
                                   (ber-decode-value stream sub-type
                                                     (cons sub-length
                                                           (append sub-type-bytes
                                                                   sub-length-bytes))))
                                 acc)))))))
      (let ((temp (coerce (iter length nil) 'vector)))
        ;; (format t "sequence: ~A~%" temp)
        temp))))

;;; export two new symbols which used by SNMP's new SMI design.
(export '(asn.1-type general-type))
